// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Point.java
// 2D Cartesian point.
// ------------------------------------------------------------------------------

class Point {
  
    /**
     * The actual coordinates.
     */
    float x;
    float y;

    /**
     * Constructor. Initialises
     * the point to the origin.
     */
    public Point() {
	x = 0;
	y = 0;
    }
    
    /**
     * Custom constructor.
     */
    Point(float X, float Y) {
	x = X;
	y = Y;
    }
    
    /**
     * Translate the point (addition)
     */
    Point add(Vector V) {
	return new Point(x+V.a, y+V.b);
    }
    
    /**
     * Translate the point (subtraction)
     */
    Point sub(Vector V) {
	return new Point(x-V.a, y-V.b);
    }
    
    /**
     * Multiplies the points coordinates by
     * a constant.
     */
    Point mul(float K) {
	return new Point(x*K, y*K);
    }
    
    /**
     * Determines the equality of two points.
     * 
     * @return - the truth!
     */
    boolean equals(Point P) {
	return (x == P.x && y == P.y);
    }
}
