// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// World.java
// The class that simulates the flowers and all the particles for the applet.
// ------------------------------------------------------------------------------

class World {
  
  ArrayList flowers = new ArrayList();          // The list of flowers
  
  /**
   * Executes a frame of the world.
   */
  void frame() {
    
    // Update the global colour variables
    updateColors();
    
    // The list of flowers is empty
    if (flowers.size() == 0) {
      
      // Create a new flower and add it
      Flower newFlower = new Flower(CAMERA_POSITION, CAMERA_ORIENTATION);
      newFlower.primary = true;
      flowers.add(newFlower);
    }
    
    // Update the flowers
    CAMERA_UPDATED = false;
    for (int i=0; i<flowers.size(); i++) {

      // Update the flower and find out whether its dead or not
      boolean alive = ((Flower) flowers.get(i)).frame();
      
      // Its dead -- kill it off
      if (!alive) {
        Flower child = ((Flower) flowers.get(i)).child;
        boolean primary = ((Flower) flowers.get(i)).primary;
        if (child != null) {
          child.primary = primary;
          flowers.remove(i);
          flowers.add(i, child);
        }
        else {
          flowers.remove(i);
        }
      }
    }
    
    // We've run out of primaries
    if (!CAMERA_UPDATED) {
      ((Flower) flowers.get(0)).primary = true;
    }
  }
  
  /**
   * Updates the global colour variables
   */
  void updateColors() {
    if (Math.abs(COLOUR_R-COLOUR_R_T) <= 2 || Math.abs(COLOUR_G-COLOUR_G_T) <= 2 || Math.abs(COLOUR_B-COLOUR_B_T) <= 2) {
      COLOUR_R_T = (float) (00 + Math.random()*255);
      COLOUR_G_T = (float) (00 + Math.random()*230);
      COLOUR_B_T = (float) (00 + Math.random()*230);
    }
    
    COLOUR_R += (COLOUR_R_T-COLOUR_R)/500;
    COLOUR_G += (COLOUR_G_T-COLOUR_G)/500;
    COLOUR_B += (COLOUR_B_T-COLOUR_B)/500;
  }
}
